#ifndef __BEAMLIST_H
#define __BEAMLIST_H

#ifndef __GRLIST_H
#include "grlist.h"
#endif

#ifndef __BEAM_H
#include "beam.h"
#endif

declare( List, InitiateBeam );
declare( ReadableList, InitiateBeam );
declare( List, TerminateBeam );
declare( ReadableList, TerminateBeam );

#ifndef BeamList
#define BeamList GENERIC( InitiateBeam, READABLE( List ) )
#define BeamListIterator GENERIC( InitiateBeam, READABLE( ListIterator ) )

#define TerminateBeamList GENERIC( TerminateBeam, READABLE( List ) )
#define TerminateBeamListIterator GENERIC( TerminateBeam, READABLE( ListIterator ) )
#endif

#endif //__BEAMLIST_H //
